package com.danielchen.demo.appreceiver;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import java.util.List;


public class ListAdapter extends ArrayAdapter<AppInfo> implements OnClickListener {


    private Callback mCallback;

    public ListAdapter(Activity activity, List<AppInfo> imageAndTexts, Callback callback) {
        super(activity, 0, imageAndTexts);

        mCallback = callback;
    }

    @Override
    public void onClick(View v) {
        // TODO Auto-generated method stub
        mCallback.click(v);
    }

    public interface Callback {
        public void click(View v);
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        Activity activity = (Activity) getContext();

        // Inflate the views from XML
        View rowView = convertView;
        LayoutCache viewCache;

        LayoutInflater inflater = activity.getLayoutInflater();

        rowView = inflater.inflate(R.layout.recyclerview_item, null);

        viewCache = new LayoutCache(rowView);
        rowView.setTag(viewCache);

        AppInfo imageAndText = getItem(position);

        // Load the image and set it on the ImageView

        TextView TextTitle = viewCache.getTextTitle();
        TextTitle.setText("" + imageAndText.getAppName());
        ImageView imageView = viewCache.getImageHeadimg();
        imageView.setImageDrawable(imageAndText.getDrawable());
        TextView TextMain = viewCache.getTextMain();
        if (imageAndText.getServer() == 1) {
            TextMain.setVisibility(View.VISIBLE);
            viewCache.getTextLine().setVisibility(View.VISIBLE);
            TextMain.setText("APP SUGGESTIONS");
        } else if (imageAndText.getServer() == 2) {
            TextMain.setVisibility(View.VISIBLE);
            viewCache.getTextLine().setVisibility(View.VISIBLE);
            TextMain.setText("OTHERS");
        }
        RelativeLayout lin_all = viewCache.getlin_all();
        lin_all.setTag(position);
        lin_all.setOnClickListener(this);

        return rowView;
    }

}
