package com.danielchen.demo.appreceiver;

import android.Manifest;
import android.annotation.TargetApi;
import android.app.ActivityManager;
import android.app.AppOpsManager;
import android.content.ActivityNotFoundException;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.location.Location;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Binder;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.Process;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.View;
import android.widget.ListView;
import android.widget.Toast;

import com.danielchen.demo.appreceiver.ListAdapter.Callback;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.lang.ref.WeakReference;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class MainActivity extends AppCompatActivity implements Callback {

    private static String TAG = MainActivity.class.getSimpleName();

    /**
     * 定位等通用权限申请
     */
    private static final int NORMAL_PERMISSION_REQUEST = 2;

    /**
     * 通用悬浮窗权限申请
     */
    private static final int FLOAT_WINDOW_PERMISSION_REQUEST = 4;

    /**
     * 小米悬浮窗进一步的权限申请
     */
    private static final int FLOAT_WINDOW_PERMISSION_REQUEST_MIUI = 6;


    /**
     * 本地 handler 事件集合
     */
    static final int MSG_FROM_REMOTE = 1;
    static final int MSG_REQUEST_NORMAL_PERMISSION = 2;
    static final int MSG_REQUEST_FLOAT_PERMISSION = 3;
    static final int MSG_REQUEST_MIUI_FLOAT_PERMISSION = 4;
    static final int MSG_REQUEST_ACCESS_SERVICE_PERMISSION = 5;
    private ListAdapter mAdapter;
    private ListView ListData;
    private MainHandler mHandler;
    private List<ResolveInfo> apps = new ArrayList<>();
    private List<AppInfo> list = new ArrayList<>();
    private List<AppInfo> list_all_app = new ArrayList<>();
    private String forheadApp = "AppReceiver";
    private String forheadpkg = "com.danielchen.demo.appreceiver";
    private String temp_appname = "AppReceiver";
    private MyReceiver receiver = null;

    public class MyReceiver extends BroadcastReceiver {
        @Override
        public void onReceive(Context context, Intent intent) {
            Bundle bundle = intent.getExtras();
            Log.e("pkgname1", bundle.getString("pkg"));
            forheadpkg = bundle.getString("pkg");
            getAppName();
            if (forheadpkg.equals(getHomes())) {
                forheadApp = "desktop";
            }
            if (!forheadApp.equals(temp_appname)) {
                temp_appname = forheadApp;
                ChangeData();
            }

        }
    }

    public void ChangeData() {
        updateApps();
        JSONArray jsonArray = new JSONArray();


        for (int i = 0; i < list.size(); i++) {

            AppInfo appInfo = list.get(i);
            jsonArray.put(appInfo.appName);


        }

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("appList", jsonArray);
            jsonObject.put("forheadapp", forheadApp);
            jsonObject.put("id", getID());
            jsonObject.put("location", getLocation());
            jsonObject.put("time", Util.format(new Date()));
        } catch (JSONException e) {

        }
        Log.e("json1", jsonObject.toString());

        getServerInfo(jsonObject.toString());
    }

    public void getAppName() {
        for (int i = 0; i < list_all_app.size(); i++) {
            AppInfo appInfo = list_all_app.get(i);
            if (forheadpkg.equals(appInfo.getPackageName())) {

                forheadApp = appInfo.getAppName();
//                forheadApp = appInfo.getPackageName();
                Log.e("main", forheadApp);
            }
        }

    }

    private String getHomes() {
        List<String> names = new ArrayList<String>();
        PackageManager packageManager = this.getPackageManager();
        //属性
        Intent intent = new Intent(Intent.ACTION_MAIN);
        intent.addCategory(Intent.CATEGORY_HOME);
        List<ResolveInfo> resolveInfo = packageManager.queryIntentActivities(intent,
                PackageManager.MATCH_DEFAULT_ONLY);
        for (ResolveInfo ri : resolveInfo) {
            names.add(ri.activityInfo.packageName);
            Log.e("main_app", ri.activityInfo.packageName);
        }

        return names.get(0);
    }

    public Handler uiHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 1:
                    Log.e("apps", "apps");
                    Log.e("apps", msg.obj + "");
                    String temp_str = msg.obj + "";
                    if (msg.obj != null) {
                        String result = "" + msg.obj;

                        String topn[] = result.split(":");
                        if (topn.length < 2) {
                            Toast.makeText(getApplicationContext(), "server data format error", Toast.LENGTH_SHORT).show();
                            break;
                        }
                        String apps[] = topn[1].split(",");


                        int index = 0;
                        for (int j = 0; j < apps.length; j++) {
                            //  Log.e("apps", apps[j]);
                            for (int i = 0; i < list.size(); i++) {
                                AppInfo appInfo = list.get(i);
                                appInfo.setServer(0);
                                String appname = appInfo.getAppName();
                                String temp1[] = appname.split("");
                                appname = "";
                                for (int t = 0; t < temp1.length; t++) {
                                    if (!temp1[t].equals(" ")) {
                                        appname = appname + temp1[t];
                                    }
                                }
                                //  Log.e("index", "" + i + appInfo.getAppName());
                                if (apps[j].equals(appname) || apps[j].equals(" " + appname)) {
                                    //  Log.e("apps", apps[j]);
                                    AppInfo temp = new AppInfo();
                                    AppInfo appIndex = list.get(index);
                                    temp.setAppName(appIndex.getAppName());
                                    temp.setDrawable(appIndex.getDrawable());
                                    temp.setPackageName(appIndex.getPackageName());
                                    appIndex.setAppName(appInfo.getAppName());
                                    appIndex.setPackageName(appInfo.getPackageName());
                                    appIndex.setDrawable(appInfo.getDrawable());
                                    appInfo.setAppName(temp.getAppName());
                                    appInfo.setPackageName(temp.getPackageName());
                                    appInfo.setDrawable(temp.getDrawable());
                                    index++;
                                }
                            }

                            AppInfo appInfo = list.get(0);
                            appInfo.setServer(1);
                            if (list.size() > index) {
                                AppInfo appInfo1 = list.get(index);
                                appInfo1.setServer(2);
                            }


                            mAdapter.notifyDataSetChanged();
                        }
                    } else {

                    }
                    break;
                default:
                    break;
            }
        }
    };

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        mHandler = new MainHandler(this);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            // 这里获取的是一般性权限，即除去悬浮窗的权限
            mHandler.obtainMessage(MSG_REQUEST_NORMAL_PERMISSION).sendToTarget();
        } else {
            // 版本小于 6.0 直接初始化界面
            initView();

        }
        receiver = new MyReceiver();
        IntentFilter filter = new IntentFilter();
        filter.addAction("com.danielchen.demo.appreceiver.Service");
        MainActivity.this.registerReceiver(receiver, filter);
        loadApps();
        Log.e("Main_app_getHomes", getHomes() + "");

    }

    private void updateApps() {
        {
            Intent intent = new Intent(Intent.ACTION_MAIN, null);
            intent.addCategory(Intent.CATEGORY_LAUNCHER);

            apps = getPackageManager().queryIntentActivities(intent, 0);
            //for循环遍历ResolveInfo对象获取包名和类名
            if (apps.size() == list_all_app.size()) {
                int flags = 0;
                for (int i = 0; i < apps.size(); i++) {

                    ResolveInfo info = apps.get(i);
                    String pkg2 = info.activityInfo.packageName;
                    for(int j=0;j<list_all_app.size();j++){
                        AppInfo appInfo = list_all_app.get(j);
                        String pkg1 = appInfo.getPackageName();
                        if (pkg1.equals(pkg2)) {
                            flags++;
                            break;
                        }
                    }


                }
                if (flags == list_all_app.size()) {
                    Log.e("update apps", "all are equal");
                    return;
                } else {
                    Log.e("update apps", "not all are equal");
                }
            } else {
                Log.e("update apps", "number is not equal");
            }

            list.clear();
            list_all_app.clear();

            Log.e("update apps", "run here");

            for (int i = 0; i < apps.size(); i++) {
                ResolveInfo info = apps.get(i);
                String packageName = info.activityInfo.packageName;
                CharSequence cls = info.activityInfo.name;
                CharSequence name = info.activityInfo.loadLabel(getPackageManager());
//          Log.e("ddddddd",name+"----"+packageName+"----"+cls);


                AppInfo appInfo = new AppInfo();

                appInfo.setAppName(name.toString());
                appInfo.setPackageName(packageName);
//            Log.e("appname",appInfo.getAppName());
                appInfo.setDrawable(info.activityInfo.loadIcon(getPackageManager()));
                list_all_app.add(appInfo);
                try {
                    if ((getPackageManager().getPackageInfo(packageName, 0).applicationInfo.flags & ApplicationInfo.FLAG_SYSTEM) <= 0) {


                    } else {
                        Log.e("appssystem", "" + name);
                        continue;
                    }
                } catch (Exception e) {

                }

                list.add(appInfo);

            }
            ListData = (ListView) findViewById(R.id.AppList);
//        Log.e("appname",list.get(4).getPackageName());
            mAdapter = new ListAdapter(this, list, this);

            ListData.setAdapter(mAdapter);

        }
    }

    private void loadApps() {
        Intent intent = new Intent(Intent.ACTION_MAIN, null);
        intent.addCategory(Intent.CATEGORY_LAUNCHER);
        getAppName();
        if (forheadpkg.equals(getHomes())) {
            forheadApp = "desktop";
        }
        apps = getPackageManager().queryIntentActivities(intent, 0);
        //for循环遍历ResolveInfo对象获取包名和类名
        list.clear();
        list_all_app.clear();
        JSONArray jsonArray = new JSONArray();


        for (int i = 0; i < apps.size(); i++) {
            ResolveInfo info = apps.get(i);
            String packageName = info.activityInfo.packageName;
            CharSequence cls = info.activityInfo.name;
            CharSequence name = info.activityInfo.loadLabel(getPackageManager());
//          Log.e("ddddddd",name+"----"+packageName+"----"+cls);


            AppInfo appInfo = new AppInfo();

            appInfo.setAppName(name.toString());
            appInfo.setPackageName(packageName);
//            Log.e("appname",appInfo.getAppName());
            appInfo.setDrawable(info.activityInfo.loadIcon(getPackageManager()));
            list_all_app.add(appInfo);
            try {
                if ((getPackageManager().getPackageInfo(packageName, 0).applicationInfo.flags & ApplicationInfo.FLAG_SYSTEM) <= 0) {


                } else {
                    Log.e("appssystem", "" + name);
                    continue;
                }
            } catch (Exception e) {

            }
            jsonArray.put(name.toString());
            list.add(appInfo);

        }
        ListData = (ListView) findViewById(R.id.AppList);
//        Log.e("appname",list.get(4).getPackageName());
        mAdapter = new ListAdapter(this, list, this);

        ListData.setAdapter(mAdapter);
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("appList", jsonArray);
            jsonObject.put("forheadapp", forheadApp);
            jsonObject.put("id", getID());
            jsonObject.put("location", getLocation());
            jsonObject.put("time", Util.format(new Date()));
        } catch (JSONException e) {

        }
        Log.e("json1", jsonObject.toString());

        getServerInfo(jsonObject.toString());
    }

    private String getID() {
        if (checkPermission(Manifest.permission.READ_PHONE_STATE, Process.myPid(), Process.myUid()) == PackageManager.PERMISSION_GRANTED) {
            TelephonyManager tm = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
            if (tm != null) {
                return tm.getDeviceId();
            }
        }
        return "";
    }

    private String getLocation() {
        String location = "";
        Location loc;
        LocationManager locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        List<String> providerList = locationManager.getProviders(true);
        String locProvider;

        if (providerList.contains(LocationManager.NETWORK_PROVIDER)) {
            locProvider = LocationManager.NETWORK_PROVIDER;
        } else if (providerList.contains(LocationManager.GPS_PROVIDER)) {
            locProvider = LocationManager.GPS_PROVIDER;
        } else {
            locProvider = "no provider";
        }

        if (!locProvider.equals("no provider")) {
            if (checkPermission(Manifest.permission.ACCESS_FINE_LOCATION, android.os.Process.myPid(), android.os.Process.myUid()) == PackageManager.PERMISSION_GRANTED || checkPermission(Manifest.permission.ACCESS_COARSE_LOCATION, android.os.Process.myPid(), android.os.Process.myUid()) == PackageManager.PERMISSION_GRANTED) {
                loc = locationManager.getLastKnownLocation(locProvider);
                if (loc != null) {
                    location = loc.getLongitude() + "," + loc.getLatitude();
                }
            }
        }
        return location;
    }


    private void initView() {
        ListData = (ListView) findViewById(R.id.AppList);
        mHandler.obtainMessage(MSG_REQUEST_ACCESS_SERVICE_PERMISSION).sendToTarget();
    }

    /**
     * 初始检查悬浮窗权限
     */
    @TargetApi(23)
    private void requestOverlay() {
        Intent intent = new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION);
        startActivityForResult(intent, FLOAT_WINDOW_PERMISSION_REQUEST);
    }


    /**
     * 判断当前系统是否是小米
     */
    private boolean isMIUI() {
        return "Xiaomi".equals(Build.MANUFACTURER);
    }


    /**
     * 打开小米权限设置界面
     */
    private void openMIUISetting() {

        try {
            Intent localIntent = new Intent("miui.intent.action.APP_PERM_EDITOR");
            localIntent.setClassName("com.miui.securitycenter", "com.miui.permcenter.permissions.PermissionsEditorActivity");
            localIntent.putExtra("extra_pkgname", getPackageName());
            startActivityForResult(localIntent, FLOAT_WINDOW_PERMISSION_REQUEST_MIUI);

        } catch (ActivityNotFoundException e1) {

            try {
                Intent localIntent = new Intent("miui.intent.action.APP_PERM_EDITOR");
                localIntent.setClassName("com.miui.securitycenter", "com.miui.permcenter.permissions.AppPermissionsEditorActivity");
                localIntent.putExtra("extra_pkgname", getPackageName());
                startActivityForResult(localIntent, FLOAT_WINDOW_PERMISSION_REQUEST_MIUI);
            } catch (ActivityNotFoundException e2) {

                Intent intent1 = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
                Uri uri = Uri.fromParts("package", getPackageName(), null);
                intent1.setData(uri);
                startActivityForResult(intent1, FLOAT_WINDOW_PERMISSION_REQUEST_MIUI);
            }
        }
    }

    /**
     * 判断小米悬浮窗权限
     */
    @TargetApi(Build.VERSION_CODES.M)
    private boolean isMIUIFloatWindowOpAllowed() {
        boolean isPermitted = false;
        AppOpsManager manager = (AppOpsManager) getSystemService(Context.APP_OPS_SERVICE);
        try {
            if (manager != null) {
                int property = manager.checkOp(AppOpsManager.OPSTR_SYSTEM_ALERT_WINDOW, Binder.getCallingUid(), getPackageName());
                isPermitted = AppOpsManager.MODE_ALLOWED == property;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return isPermitted;
    }


    /**
     * 跳转到无障碍服务设置页面
     */
    private void openAccessServiceSetting() {
        Intent intent = new Intent(Settings.ACTION_ACCESSIBILITY_SETTINGS);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(intent);
    }

    /**
     * 判断是否有辅助功能权限
     */
    private boolean isAccessibilitySettingsOn(String className) {
        ActivityManager activityManager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
        List<ActivityManager.RunningServiceInfo> runningServices = activityManager.getRunningServices(100);
        if (runningServices != null && runningServices.size() > 0) {
            for (int i = 0; i < runningServices.size(); i++) {
                ComponentName service = runningServices.get(i).service;
                if (service.getClassName().equals(className)) {
                    return true;
                }
            }
        }
        return false;
    }

    /**
     * 初始化需要检查的一般权限
     */
    private String[] initRequestNormalPermissions() {
        List<String> permissions = new ArrayList<>();
        permissions.add(Manifest.permission.ACCESS_FINE_LOCATION);
        permissions.add(Manifest.permission.ACCESS_COARSE_LOCATION);
        permissions.add(Manifest.permission.WRITE_EXTERNAL_STORAGE);
        permissions.add(Manifest.permission.READ_EXTERNAL_STORAGE);
        permissions.add(Manifest.permission.READ_PHONE_STATE);
        return permissions.toArray(new String[permissions.size()]);
    }

    /**
     * 检查有多少一般权限没有拿到手，需要申请
     *
     * @param need 预计需要的权限
     * @return 实际需要的权限
     */
    @TargetApi(23)
    private String[] getRequestNormalPermissions(String[] need) {
        List<String> permissions = new ArrayList<>();
        for (String permission : need) {
            if (checkSelfPermission(permission) != PackageManager.PERMISSION_GRANTED) {
                permissions.add(permission);
            }
        }
        if (permissions.size() < 1) {
            return null;
        } else {
            return permissions.toArray(new String[permissions.size()]);
        }
    }

    @TargetApi(23)
    private void requestPermissions(String[] realNeed) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            if (realNeed.length > 0) {
                requestPermissions(realNeed, NORMAL_PERMISSION_REQUEST);
            }
        }
    }

    @TargetApi(23)
    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == NORMAL_PERMISSION_REQUEST) {
            for (int i : grantResults) {
                if (i == PackageManager.PERMISSION_DENIED) {
                    Toast.makeText(this, "缺少必须权限，退出应用", Toast.LENGTH_SHORT).show();
                    finish();
                }
            }
            // 获取一般权限后 开始申请悬浮窗权限
            mHandler.obtainMessage(MSG_REQUEST_FLOAT_PERMISSION).sendToTarget();
        }
    }

    @TargetApi(23)
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        switch (requestCode) {
            case FLOAT_WINDOW_PERMISSION_REQUEST:
                if (Settings.canDrawOverlays(this)) {
                    mHandler.obtainMessage(MSG_REQUEST_MIUI_FLOAT_PERMISSION).sendToTarget();
                } else {
                    Toast.makeText(this, "开启悬浮窗失败", Toast.LENGTH_SHORT).show();
                    finish();
                }
                break;

            case FLOAT_WINDOW_PERMISSION_REQUEST_MIUI:
                if (!isMIUIFloatWindowOpAllowed()) {
                    Toast.makeText(this, "开启悬浮窗失败", Toast.LENGTH_SHORT).show();
                    finish();
                } else {
                    initFloatWindow();
                    initView();
                }
                break;

            default:
                break;
        }
    }

    public static final class MainHandler extends Handler {

        private final WeakReference<MainActivity> mActivity;

        private final Pattern pattern = Pattern.compile("^TOPN:\\s*(\\S*)$");

        MainHandler(MainActivity activity) {
            mActivity = new WeakReference<>(activity);
        }

        @Override
        public void handleMessage(Message msg) {
            final MainActivity act = mActivity.get();
            if (act != null) {
//                Log.e("appname",(String)msg.obj);
                switch (msg.what) {

                    case MSG_FROM_REMOTE:
                        // 后台返回的是应用的名称，不是包名
//Log.e("pkgname1",""+msg.obj);
//                        String[] appNames = getRemoteAppNames((String) msg.obj);
//                        if (appNames != null) {
//                            List<AppInfo> la = new ArrayList<>(appNames.length);
//                            for (String appName : appNames) {
//                                if (act.appInfoMap.containsKey(appName)) {
//                                    la.add(act.appInfoMap.get(appName));
//                                }
//                            }
//                            act.adapter.update(la);
//                        }
                        break;

                    case MSG_REQUEST_NORMAL_PERMISSION:
                        String[] need = act.initRequestNormalPermissions();
                        String[] realNeed;
                        if ((realNeed = act.getRequestNormalPermissions(need)) != null) {
                            act.requestPermissions(realNeed);
                        } else {
                            obtainMessage(MSG_REQUEST_FLOAT_PERMISSION).sendToTarget();
                        }
                        break;

                    case MSG_REQUEST_FLOAT_PERMISSION:
                        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                            if (!Settings.canDrawOverlays(act)) {
                                act.requestOverlay();
                            } else {
                                obtainMessage(MSG_REQUEST_MIUI_FLOAT_PERMISSION).sendToTarget();
                            }
                        }
                        break;

                    case MSG_REQUEST_MIUI_FLOAT_PERMISSION:
                        if (act.isMIUI()) {
                            if (act.isMIUIFloatWindowOpAllowed()) {
                                act.initFloatWindow();
                                act.initView();
                            } else {
                                act.openMIUISetting();
                            }
                        } else {
                            act.initFloatWindow();
                            act.initView();
                        }
                        break;


                    case MSG_REQUEST_ACCESS_SERVICE_PERMISSION:
                        if (!act.isAccessibilitySettingsOn(Service.class.getName())) {
                            act.openAccessServiceSetting();
                        }
                        //   act.initServiceData();
                        break;

                    default:
                        break;
                }
            }
        }

        /**
         * 解析远端返回的数据，获得app名称列表
         * 例子：TOPN: 链家,知乎,新云,慕课网
         */
        private String[] getRemoteAppNames(String input) {
            Matcher m = pattern.matcher(input);
            if (m.find()) {
                return m.group(1).split(",");
            }
            return null;
        }
    }

    private void initFloatWindow() {
        ViewManager.getInstance().showFloatBall(getApplicationContext());
    }

    @Override
    public void click(View v) {
        // TODO Auto-generated method stub
        switch (v.getId()) {
            case R.id.rea_all:
                AppInfo appInfo = list.get((Integer) v.getTag());
                Intent launcher = getPackageManager().getLaunchIntentForPackage(appInfo.getPackageName());

                if (launcher != null) {
                    startActivity(launcher);
                }
//
                break;
            default:
                break;
        }
    }

    public String getServerInfo(final String info) {
        {
            new Thread(new Runnable() { // 开启线程上传
                @Override
                public void run() {
                    try {
                        Socket socket = new Socket("169.236.70.41", 8082);  # IP address @ port

                        OutputStream os = socket.getOutputStream();

                        PrintWriter send = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream(), "gbk")));
                        Log.e("apps", info);
                        send.println(info);
                        send.flush();

                        socket.shutdownOutput();

                        InputStream is = socket.getInputStream();
                        InputStreamReader isr = new InputStreamReader(is, "gbk");
                        BufferedReader br = new BufferedReader(isr);

                        String info = null;
                        Message msg = new Message();
                        msg.obj = info;
                        msg.what = 1;
                        while ((info = br.readLine()) != null) {

                            System.out.println("" + info);
                            Log.e("text", info);
                            msg.obj = info;
                        }


                        uiHandler.sendMessage(msg);
                        br.close();
                        isr.close();
                        is.close();
                        send.close();
                        os.close();
                        socket.close();
                    } catch (UnknownHostException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    } catch (IOException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }

                }
            }).start();
        }
        return "";
    }
}

