# Mobile Application Usage Prediction

This is the code for paper "ATPP: A Mobile App Prediction System Based on Deep Marked Temporal Point Processes".

******
## Overview
1. [AppReceiver](#AppReceiver)
2. [AppTimePre](#AppTimePre)
3. [App-release.apk](#App-release.apk)
4. [License](#license)
5. [Contact](#contact)

******
## 1. AppReceiver
* It is the project of Android mobile application implementation.
* You need to use Android Studio 3.x to open this project.
* The main file is located in ./AppReceiver/app/src/main/java/com/danielchen/demo/appreceiver/MainActivity.java

******
## 2. AppTimePre

* It is the project of algorithm implementation.
* The main file is located in ./AppTimePre/src/run.py

### 2.1 Datasets
We release the anonymized sample data for the evauluation.

* `apps-train.txt` : userID|appID1|appID2...

* `locations-train.txt` : userID|location1|location2...

* `times-train.txt` : userID|time1|time2...

* `apps-test.txt` : userID|appID1|appID2...

* `locations-test.txt` : userID|location1|location2...

* `times-test.txt` : userID|time1|time2...
 

### 2.2 Dependencies
The following modules are needed.

- `Ubuntu 16.04`
- `Python >=3.5`
- `Tensorflow >=1.x`

### 2.3 Execution
```
$ python run.py ../data/apps-train.txt ../data/locations-train.txt ../data/times-train.txt ../data/apps-test.txt ../data/locations-test.txt ../data/times-test.txt 
```

******
## 3. app-release.apk
* It is generated by AppReceiver project.

******
## 4. License
* The code is developed under the MPL-02.0 license.

******
## 5. Contact
* If you have any questions, please do not hesitate to send an email to us (E-mail address： kyang73@ucmerced.edu).




